/* CPACUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int cpacur_(radius, freq, pol, npts, lunit)
real *radius, *freq, *pol;
integer *npts, *lunit;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1, i__2, i__3;
    complex q__1, q__2;
    static real equiv_0[19];
    static complex equiv_1[10];

    /* Builtin functions */
    double sqrt();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_1)
    static integer krec;
#define ibuf ((integer *)equiv_0)
#define curm ((complex *)((integer *)equiv_1 + 13))
    static integer i__, k;
    static real wavel;
    static complex am[3];
    static real hp;
    extern doublereal cradcn_();
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int cpperm_();
    static real rad, amm, per, pos;

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 0, 0, 0, 1 };
    static cilist io___19 = { 0, 0, 0, 0, 0 };



/*  Currents file of circular microstrip patch */

/*  RADIUS    Effective radius of patch (m) */
/*  FREQ      Frequency (GHz) */
/*  POL	     Polarization: 0 linear, -1 RHC, +1 LHC */
/*  NPTS      Number of points in integrals */

/*  LUNIT     Logical unit of random access file with currents */

    wavel = cc / *freq;
    *pk = pi * (float)2. / wavel;
    rad = *radius / wavel;
/* --------------- Find maximum magnetic current for 1 w. input */
    amm = sqrt((float)1. / cradcn_(&rad)) * (float)2.;
    ibuf[0] = *npts;
    ibuf[1] = 2;
    io___10.ciunit = *lunit;
    s_wdue(&io___10);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    krec = 1;
    per = pi * (float)2. * *radius;
    hp = per / *npts;
    i__1 = *npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	pos = hp * (i__ - 1);
	cpperm_(&pos, radius, frec, am, pol);
	++krec;
	for (k = 1; k <= 3; ++k) {
/* L1: */
	    i__2 = k - 1;
	    i__3 = k - 1;
	    q__2.r = amm * am[i__3].r, q__2.i = amm * am[i__3].i;
	    q__1.r = hp * q__2.r, q__1.i = hp * q__2.i;
	    curm[i__2].r = q__1.r, curm[i__2].i = q__1.i;
	}
	io___19.ciunit = *lunit;
	io___19.cirec = krec;
	s_wdue(&io___19);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cpacur_ */

#undef pk
#undef curm
#undef ibuf
#undef frec


