/* CPPERM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int cpperm_(p, rad, pos, am, pol)
real *p, *rad, *pos;
complex *am;
real *pol;
{
    /* Initialized data */

    static real s2 = (float)1.1421356;

    /* System generated locals */
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5;

    /* Builtin functions */
    double sin(), cos();

    /* Local variables */
    static real ph;


/*  Perimeter function of circular patch */

/*  P   Perimeter value (0 starts on X axis) */
/*  RAD Radius */
/*  POS    Position on patch centered on origin */
/*  AM(3)  Normalized magnetic current direction */
/*  POL	  Polarization: 0 Linear, -1 RHC, +1 LHC */

    /* Parameter adjustments */
    --am;
    --pos;

    /* Function Body */
    ph = *p / *rad;
    pos[3] = (float)0.;
    am[3].r = (float)0., am[3].i = (float)0.;
    r__1 = -sin(ph) * cos(ph);
    am[1].r = r__1, am[1].i = (float)0.;
    r__1 = cos(ph) * cos(ph);
    am[2].r = r__1, am[2].i = (float)0.;
    if (*pol != (float)0.) {
	q__5.r = (float)0., q__5.i = *pol;
	r__1 = sin(ph);
	q__4.r = r__1 * q__5.r, q__4.i = r__1 * q__5.i;
	r__2 = sin(ph);
	q__3.r = r__2 * q__4.r, q__3.i = r__2 * q__4.i;
	q__2.r = am[1].r - q__3.r, q__2.i = am[1].i - q__3.i;
	q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	am[1].r = q__1.r, am[1].i = q__1.i;
	q__5.r = (float)0., q__5.i = *pol;
	r__1 = cos(ph);
	q__4.r = r__1 * q__5.r, q__4.i = r__1 * q__5.i;
	r__2 = sin(ph);
	q__3.r = r__2 * q__4.r, q__3.i = r__2 * q__4.i;
	q__2.r = am[2].r + q__3.r, q__2.i = am[2].i + q__3.i;
	q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	am[2].r = q__1.r, am[2].i = q__1.i;
    }
    pos[1] = cos(ph) * *rad;
    pos[2] = sin(ph) * *rad;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cpperm_ */

