/* DSKBLN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)-1.;
static real c_b3 = (float)1.;

doublereal dskbln_(xb, xs, xf)
real *xb, *xs, *xf;
{
    /* System generated locals */
    real ret_val, r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real dist;
    static integer i__;
    static real p[3], t;
    extern /* Subroutine */ int vlinc_(), pints_();
    static real fs[3], fsl;
    extern doublereal dot_();
    static integer nis;


/*  Disk blockage function for near field */

/*  XB(1)  X position of disk center */
/*     2   Y position of disk center */
/*     3   Z position of disk center */
/*     4   Radius of disk */
/*     5   Unit normal to disk (X component) */
/*     6   Unit normal to disk (Y component) */
/*     7   Unit normal to disk (Z component) */
/*  XS     Source point */
/*  XF     Field point */

    /* Parameter adjustments */
    --xf;
    --xs;
    --xb;

    /* Function Body */
    vlinc_(&c_b2, &xs[1], &c_b3, &xf[1], fs);
    fsl = sqrt(dot_(fs, fs));
    for (i__ = 1; i__ <= 3; ++i__) {
/* L1: */
	fs[i__ - 1] /= fsl;
    }
    ret_val = (float)0.;
    pints_(&xs[1], fs, &xb[1], &xb[5], &t, p, &nis);
    if (nis == -1) {
	return ret_val;
    }
/* Computing 2nd power */
    r__1 = p[0] - xb[1];
/* Computing 2nd power */
    r__2 = p[1] - xb[2];
/* Computing 2nd power */
    r__3 = p[2] - xb[3];
    dist = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
    if (dist > xb[4] || t < (float)0.) {
	return ret_val;
    }
    if (dist <= xb[4] && t > fsl) {
	return ret_val;
    }
    ret_val = (float)1.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* dskbln_ */

