/* MTMULT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int mtmult_(a, b, c__, nr, nn, nc)
real *a, *b, *c__;
integer *nr, *nn, *nc;
{
    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3;

    /* Local variables */
    static integer i__, j, k;


/*  Matrix Multiplication A x B = C */

/*  NR  Number of Rows of A and C */
/*  NN  Number of columns of A and Number of rows of B */
/*  NC  Number of columns of B and C */

    /* Parameter adjustments */
    a_dim1 = *nr;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    c_dim1 = *nr;
    c_offset = c_dim1 + 1;
    c__ -= c_offset;
    b_dim1 = *nn;
    b_offset = b_dim1 + 1;
    b -= b_offset;

    /* Function Body */
    i__1 = *nr;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *nc;
	for (j = 1; j <= i__2; ++j) {
	    c__[i__ + j * c_dim1] = (float)0.;
	    i__3 = *nn;
	    for (k = 1; k <= i__3; ++k) {
/* L2: */
		c__[i__ + j * c_dim1] += a[i__ + k * a_dim1] * b[k + j * 
			b_dim1];
	    }
/* L1: */
	}
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* mtmult_ */

