/* PABGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b4 = (float)1.;
static integer c__1 = 1;

/* Subroutine */ int pabgeo_(xmin, xmax, ymin, ymax, focus, block, xb, vp, nx,
	 ny, lunit)
real *xmin, *xmax, *ymin, *ymax, *focus;
doublereal (*block) ();
real *xb, *vp;
integer *nx, *ny, *lunit;
{
    /* Initialized data */

    static real vr[3] = { (float)0.,(float)0.,(float)1. };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real frec[19];
    static integer krec, ibuf[19], i__, j;
    extern /* Subroutine */ int vlinc_(), normp_();
    static integer nn;
    static real pp[3], hx, hy, rp;

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 0, 0, 0, 0 };
    static cilist io___13 = { 0, 0, 0, 0, 1 };



/*  Paraboloidal Reflector Geometry for Currents File */
/*  using rectangular grid and external blockage function for rim */

/*  XMIN    Minimum X axis position of rim */
/*  XMAX    Maximum X axis position of rim */
/*  YMIN    Minimum Y axis position of rim */
/*  YMAX    Maximum Y axis position of rim */
/*  FOCUS   Focal length */
/*  BLOCK   External blockage function to determine rim shape */
/*  XB( )   Blockage function variables */
/*  VP(3)   Location of parent paraboloid vertex */
/*  Note:   Paraboloid axis along Z-axis */
/*  NX      Number of points in X-axis integrals */
/*  NY      Number of points in Y-axis integrals */
/*  LUNIT   Logical unit of random access file for currents */

    /* Parameter adjustments */
    --vp;
    --xb;

    /* Function Body */
    hx = (*xmax - *xmin) / *nx;
    hy = (*ymax - *ymin) / *ny;
    krec = 1;
/*  ------------- Loop over X-axis */
    i__1 = *nx;
    for (j = 1; j <= i__1; ++j) {
	pp[0] = *xmin + hx * (j - (float).5);
	i__2 = *ny;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    pp[1] = *ymin + hy * (i__ - (float).5);
	    pp[2] = (float)-1.;
	    if ((*block)(&xb[1], pp, vr) == (float)1.) {
/*  ------------- Point within rim */
/* Computing 2nd power */
		r__1 = pp[0];
/* Computing 2nd power */
		r__2 = pp[1];
		rp = sqrt(r__1 * r__1 + r__2 * r__2);
		pp[2] = rp * rp / (float)4. / *focus;
/*  ------------- Find unit normal */
		normp_(pp, focus, &frec[4]);
/*  ------------- Adjust area */
		frec[3] = hx * hy / frec[6];
		vlinc_(&c_b4, &vp[1], &c_b4, pp, frec);
		++krec;
		io___10.ciunit = *lunit;
		io___10.cirec = krec;
		s_wdue(&io___10);
		for (nn = 1; nn <= 19; ++nn) {
		    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real))
			    ;
		}
		e_wdue();
	    }
/* L1: */
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 1;
    io___13.ciunit = *lunit;
    s_wdue(&io___13);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* pabgeo_ */

