/* patinf.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static doublereal c_b8 = 10.;
static real c_b10 = (float)360.;
static real c_b11 = (float)180.;
static real c_b14 = (float)1.;
static integer c__2 = 2;

/* Subroutine */ int patinf_(lunit, inst, theta, phi, et, ep)
integer *lunit, *inst;
real *theta, *phi;
complex *et, *ep;
{
    /* Initialized data */

    static real tr = (float).01745329;
    static real gcons = (float).1826374;

    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3, r__4;
    doublereal d__1;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8;

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue();
    double pow_dd(), r_mod(), sin(), r_sign();

    /* Local variables */
    static integer ibuf[4], i__;
    static real t, u;
    static complex x[4], y[4];
    extern /* Subroutine */ int arads_();
    static integer nscan, itype;
    extern /* Subroutine */ int retsp_();
    static integer nm, nn, np, nt;
    static real sp[3], sr[3], vp, vt;
    static integer npoint;
    static real dsc, phh, thh, scp, sgn, scs, dst, tin, stp, sts;

    /* Fortran I/O blocks */
    static cilist io___3 = { 0, 0, 0, 0, 1 };
    static cilist io___9 = { 0, 0, 0, 0, 2 };
    static cilist io___32 = { 0, 0, 0, 0, 0 };
    static cilist io___33 = { 0, 0, 0, 0, 0 };
    static cilist io___34 = { 0, 0, 0, 0, 0 };
    static cilist io___35 = { 0, 0, 0, 0, 0 };



/*  Interpolation from multiple patterns */
/*  using bilinear interpolation from file with Theta & Phi components */
/*  This routine requires static storage */
/*  It can use multiple files if they have the same structure and use */
/*  the same multipliers */

/*  INST    - 1 Initialize: */
/*            2 Return pattern value */
/*  THETA       Pattern Angle (deg) (Value to add to bias to gain */
/*              on initialization dB) */
/*  PHI         Pattern Angle (deg) (Value to add to bias to gain */
/*              on initialization dB) */
/*  ET          Complex electric field V/m @ 1 m, 1 w input Theta */
/*  EP          Complex electric field V/m @ 1 m, 1 w input Phi */

    if (*inst < 2) {

/*  Reads random access data file LU = LUNIT, open before calling */

/* ------- Initialize */
/*  1st record: */
/*  Type: [1 Conic, 2 Great Circle], # Scans, # Points in scan */
/*  Type = -2 if Theta > 180 or Theta < 0 included */

/*  2nd record:  Step angles: Start, Step; Scan angles: Start, Step */
/*  3rd record & following: Theta, Phi Components (Complex voltages) 
*/

	io___3.ciunit = *lunit;
	s_rdue(&io___3);
	for (nn = 1; nn <= 4; ++nn) {
	    do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
	}
	e_rdue();
	itype = ibuf[0];
	nscan = ibuf[1];
	npoint = ibuf[2];
	io___9.ciunit = *lunit;
	s_rdue(&io___9);
	do_uio(&c__1, (char *)&sts, (ftnlen)sizeof(real));
	do_uio(&c__1, (char *)&stp, (ftnlen)sizeof(real));
	do_uio(&c__1, (char *)&scs, (ftnlen)sizeof(real));
	do_uio(&c__1, (char *)&scp, (ftnlen)sizeof(real));
	e_rdue();
	d__1 = (doublereal) (*theta / (float)20.);
	vt = pow_dd(&c_b8, &d__1) / gcons;
	d__1 = (doublereal) (*phi / (float)20.);
	vp = pow_dd(&c_b8, &d__1) / gcons;
    } else {
/* -------- Return value */
	sp[0] = (float)1.;
	sp[1] = tr * *theta;
	sp[2] = tr * *phi;
/* -------- Convert to rectangular and back to spherical */
	arads_(sp, sr);
	retsp_(sr, sp);
	if (itype == 1) {
/* -------- Conical patterns */
	    thh = sp[1] / tr;
	    phh = sp[2] / tr;
	} else {
/* -------- Great circle patterns */
	    thh = sp[2] / tr;
	    phh = sp[1] / tr;
	    if (thh < (float)0. && itype == -2) {
		phh = (float)360. - phh;
		thh += (float)180.;
	    }
	}
	if (itype != 2) {
	    nm = (float)360. / scp + (float).1;
	}
	if (itype == 2) {
	    nm = (float)180. / scp + (float).1;
	}
	dsc = phh - scs;
	if (itype != 2) {
	    dsc = r_mod(&dsc, &c_b10);
	}
	if (itype == 2 && (r__1 = dsc - (float)180., dabs(r__1)) > (float).02)
		 {
	    dsc = r_mod(&dsc, &c_b11);
	}
	dsc /= scp;
	if (dsc < (float)0.) {
	    dsc += nm;
	}
	np = dsc;
	t = dsc - np;
	++np;
	if (np == nm) {
	    --np;
	    t += 1;
	}
	if (itype == 2) {
	    nm = (float)360. / stp + (float).1;
	}
	if (itype != 2) {
	    nm = (float)180. / stp + (float).1;
	}
	dst = thh - sts;
	if (itype == 2) {
	    dst = r_mod(&dst, &c_b10);
	}
	if (itype != 2 && (r__1 = dst - (float)180., dabs(r__1)) > (float).02)
		 {
	    dst = r_mod(&dst, &c_b11);
	}
	dst /= stp;
	if (dst < (float)0.) {
	    dst += nm;
	}
	nt = dst;
	u = dst - nt;
	++nt;
	if (itype == 1) {
	    tin = sts + (nt - 1) * stp;
	}
	if (abs(itype) == 2) {
	    tin = scs + (np - 1) * scp;
	}
	r__1 = sin(tin * tr);
	sgn = r_sign(&c_b14, &r__1);
	for (i__ = 1; i__ <= 4; ++i__) {
	    i__1 = i__ - 1;
	    y[i__1].r = (float)0., y[i__1].i = (float)0.;
/* L3: */
	    i__1 = i__ - 1;
	    x[i__1].r = (float)0., x[i__1].i = (float)0.;
	}
/* -------- Pick points for bilinear interpolation */
	if (np <= npoint && nt - 1 <= nscan) {
	    nn = np + (nt - 1) * npoint + 2;
	    io___32.ciunit = *lunit;
	    io___32.cirec = nn;
	    s_rdue(&io___32);
	    do_uio(&c__2, (char *)&y[0], (ftnlen)sizeof(real));
	    do_uio(&c__2, (char *)&x[0], (ftnlen)sizeof(real));
	    e_rdue();
	    if (np + 1 <= npoint && nt - 1 <= nscan) {
		nn = np + 1 + (nt - 1) * npoint + 2;
		io___33.ciunit = *lunit;
		io___33.cirec = nn;
		s_rdue(&io___33);
		do_uio(&c__2, (char *)&y[1], (ftnlen)sizeof(real));
		do_uio(&c__2, (char *)&x[1], (ftnlen)sizeof(real));
		e_rdue();
	    }
	}
	if (np + 1 <= npoint && nt < nscan) {
	    nn = np + nt * npoint + 2;
	    io___34.ciunit = *lunit;
	    io___34.cirec = nn;
	    s_rdue(&io___34);
	    do_uio(&c__2, (char *)&y[3], (ftnlen)sizeof(real));
	    do_uio(&c__2, (char *)&x[3], (ftnlen)sizeof(real));
	    e_rdue();
	    if (np + 1 <= npoint && nt < nscan) {
		nn = np + 1 + nt * npoint + 2;
		io___35.ciunit = *lunit;
		io___35.cirec = nn;
		s_rdue(&io___35);
		do_uio(&c__2, (char *)&y[2], (ftnlen)sizeof(real));
		do_uio(&c__2, (char *)&x[2], (ftnlen)sizeof(real));
		e_rdue();
	    }
	}
	r__1 = ((float)1. - t) * ((float)1. - u);
	q__5.r = r__1 * y[0].r, q__5.i = r__1 * y[0].i;
	r__2 = t * ((float)1. - u);
	q__6.r = r__2 * y[1].r, q__6.i = r__2 * y[1].i;
	q__4.r = q__5.r + q__6.r, q__4.i = q__5.i + q__6.i;
	r__3 = t * u;
	q__7.r = r__3 * y[2].r, q__7.i = r__3 * y[2].i;
	q__3.r = q__4.r + q__7.r, q__3.i = q__4.i + q__7.i;
	r__4 = ((float)1. - t) * u;
	q__8.r = r__4 * y[3].r, q__8.i = r__4 * y[3].i;
	q__2.r = q__3.r + q__8.r, q__2.i = q__3.i + q__8.i;
	q__1.r = vt * q__2.r, q__1.i = vt * q__2.i;
	et->r = q__1.r, et->i = q__1.i;
	r__1 = ((float)1. - t) * ((float)1. - u);
	q__5.r = r__1 * x[0].r, q__5.i = r__1 * x[0].i;
	r__2 = t * ((float)1. - u);
	q__6.r = r__2 * x[1].r, q__6.i = r__2 * x[1].i;
	q__4.r = q__5.r + q__6.r, q__4.i = q__5.i + q__6.i;
	r__3 = t * u;
	q__7.r = r__3 * x[2].r, q__7.i = r__3 * x[2].i;
	q__3.r = q__4.r + q__7.r, q__3.i = q__4.i + q__7.i;
	r__4 = ((float)1. - t) * u;
	q__8.r = r__4 * x[3].r, q__8.i = r__4 * x[3].i;
	q__2.r = q__3.r + q__8.r, q__2.i = q__3.i + q__8.i;
	q__1.r = vp * q__2.r, q__1.i = vp * q__2.i;
	ep->r = q__1.r, ep->i = q__1.i;
	q__1.r = sgn * et->r, q__1.i = sgn * et->i;
	et->r = q__1.r, et->i = q__1.i;
	q__1.r = sgn * ep->r, q__1.i = sgn * ep->i;
	ep->r = q__1.r, ep->i = q__1.i;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* patinf_ */

