/* POLBKN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)-1.;
static real c_b3 = (float)1.;

doublereal polbkn_(xb, xs, xf)
real *xb, *xs, *xf;
{
    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real test;
    static integer i__;
    static real t;
    extern /* Subroutine */ int vlinc_(), pints_();
    static real fs[3], pt[3];
    static integer nv;
    extern doublereal polyin_();
    static real fsl;
    extern doublereal dot_();
    static integer nis;


/*  Polygon disk blockage function for near field */

/*  XB         Blockage function vector */
/*      1      Number of vertices */
/*      2 - 4  Unit normal */
/*      5 -    Vertices */

/*  XS(3)      Source point */
/*  VR(3)      Radial unit vector */

    /* Parameter adjustments */
    --xf;
    --xs;
    --xb;

    /* Function Body */
    vlinc_(&c_b2, &xs[1], &c_b3, &xf[1], fs);
    fsl = sqrt(dot_(fs, fs));
    for (i__ = 1; i__ <= 3; ++i__) {
/* L1: */
	fs[i__ - 1] /= fsl;
    }
    ret_val = (float)0.;
    nv = xb[1];
    pints_(&xs[1], fs, &xb[5], &xb[2], &t, pt, &nis);
    if (nis == -1 || t < (float)0.) {
	return ret_val;
    }
    test = polyin_(pt, &xb[5], &nv, &xb[2]);
    if (test == (float)-1.) {
	return ret_val;
    }
    if (t > fsl) {
	return ret_val;
    }
    ret_val = (float)1.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* polbkn_ */

