/* POLBKP.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;
static real c_b9 = (float)1.;

/* Subroutine */ int polbkp_(vt, nv, ct, rot, xb)
real *vt;
integer *nv;
real *ct, *rot, *xb;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__, k;
    extern /* Subroutine */ int vlinc_();
    static real an[3];
    static integer kk;
    extern /* Subroutine */ int polynm_(), mtmult_();


/*  Polygon Disk Blockage Preparation */

/*  VT(3,NV)   Vertices of polygon ordered CCW around Normal (in */
/*             X-Y plane) */
/*  NV         Number of vertices */
/*  CT(3)      Center of poylgon after rotation */
/*  ROT(3,3)   Rotation matrix (polygon rotated off X-Y plane) */
/*  XB         Blockage function vector */
/*      1      Number of vertices */
/*      2 - 4  Unit normal */
/*      5 -    Vertices */

    /* Parameter adjustments */
    --xb;
    rot -= 4;
    --ct;
    --vt;

    /* Function Body */
    xb[1] = (real) (*nv);
    polynm_(&vt[1], an);
    mtmult_(an, &rot[4], &xb[2], &c__1, &c__3, &c__3);
    i__1 = *nv;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = (i__ - 1) * 3 + 1;
	kk = (i__ - 1) * 3 + 5;
	mtmult_(&vt[k], &rot[4], &xb[kk], &c__1, &c__3, &c__3);
/* L1: */
	vlinc_(&c_b9, &xb[kk], &c_b9, &ct[1], &xb[kk]);
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* polbkp_ */

