/* POLYNM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int polynm_(vt, an)
real *vt, *an;
{
    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__;
    extern /* Subroutine */ int cross_();
    static real v1[3], v2[3], al;
    extern doublereal dot_();


/*  Unit normal to planar polygon */

/*  VT(3,NT)   Vertices of polygon */
/*  AN(3)      Returned unit normal */

/*  It is assumed that the vertices are ordered CCW around the normal */

    /* Parameter adjustments */
    --an;
    --vt;

    /* Function Body */
    for (i__ = 1; i__ <= 3; ++i__) {
	v1[i__ - 1] = vt[i__ + 6] - vt[i__ + 3];
/* L1: */
	v2[i__ - 1] = vt[i__] - vt[i__ + 3];
    }
    cross_(v1, v2, &an[1]);
    al = sqrt(dot_(&an[1], &an[1]));
    for (i__ = 1; i__ <= 3; ++i__) {
/* L2: */
	an[i__] /= al;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* polynm_ */

