/* PYRGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b3 = (float)1.;
static integer c__1 = 1;

/* Subroutine */ int pyrgeo_(height, alinc, xpb, lunit)
real *height, *alinc, *xpb;
integer *lunit;
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Builtin functions */
    double sqrt();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real edge, frec[19];
    static integer krec, ibuf[19];
    static real cent[3];
    static integer nsub, i__, j, k;
    extern /* Subroutine */ int vlinc_(), trian_(), cross_();
    static real an;
    static integer ii, jj, kk, nn, nv, is1, is2, is3;
    static real pp1[3], pp2[3], pp3[3], tp1[3], tp2[3], tp3[3], fac, alc;
    extern doublereal dot_();

    /* Fortran I/O blocks */
    static cilist io___20 = { 0, 0, 0, 0, 0 };
    static cilist io___27 = { 0, 0, 0, 0, 0 };
    static cilist io___28 = { 0, 0, 0, 0, 0 };
    static cilist io___30 = { 0, 0, 0, 0, 1 };



/*  Pyramid Geometry Generation */

/*  HEIGHT   Height of pyramid above plane */
/*  ALINC    Minimum length along edges */
/*  XPB      Blockage of array of base polygon */
/*  LUNIT    Logical unit of random access file for currents */

    /* Parameter adjustments */
    --xpb;

    /* Function Body */
    nv = xpb[1] + (float).1;
    cent[0] = (float)0.;
    cent[1] = (float)0.;
    cent[2] = (float)0.;
/*  ------------- Find center point of polygon */
    i__1 = nv;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    cent[j - 1] += xpb[i__ * 3 + j + 1] / nv;
	}
    }
/*  ------------- Find vertex of pyramid */
    vlinc_(&c_b3, cent, height, &xpb[2], pp1);
/*  ------------- Loop on base vertices */
    krec = 1;
    i__1 = nv;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = i__ % nv + 1;
/*  ------------- Find vertices of triangle */
	for (j = 1; j <= 3; ++j) {
	    pp2[j - 1] = xpb[i__ * 3 + j + 1] + *alinc * xpb[j + 1];
	    pp3[j - 1] = xpb[k * 3 + j + 1] + *alinc * xpb[j + 1];
	    tp1[j - 1] = pp2[j - 1] - pp1[j - 1];
	    tp2[j - 1] = pp3[j - 1] - pp1[j - 1];
/* L2: */
	    tp3[j - 1] = pp3[j - 1] - pp2[j - 1];
	}
/*  ------------- Find patches normal to plane */
	edge = sqrt(dot_(tp3, tp3));
	is3 = edge / *alinc + 1;
	frec[3] = *alinc * edge / is3;
	cross_(tp3, &xpb[2], &frec[4]);
	an = sqrt(dot_(&frec[4], &frec[4]));
	for (j = 1; j <= 3; ++j) {
/* L3: */
	    frec[j + 3] /= an;
	}
	i__2 = is3;
	for (ii = 1; ii <= i__2; ++ii) {
	    fac = ((real) ii - (float).5) / (real) is3;
	    vlinc_(&c_b3, pp2, &fac, tp3, frec);
	    alc = -(*alinc) / (float)2.;
	    vlinc_(&c_b3, frec, &alc, &xpb[2], frec);
	    ++krec;
/* L4: */
	    io___20.ciunit = *lunit;
	    io___20.cirec = krec;
	    s_wdue(&io___20);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/*  ------------- Find unit normal to plane */
	cross_(tp1, tp2, &frec[4]);
	an = sqrt(dot_(&frec[4], &frec[4]));
	for (j = 1; j <= 3; ++j) {
/* L5: */
	    frec[j + 3] /= an;
	}
	is1 = sqrt(dot_(tp1, tp1)) / *alinc + 1;
	is2 = sqrt(dot_(tp2, tp2)) / *alinc + 1;
/* Computing MAX */
	i__2 = max(is1,is2);
	nsub = max(i__2,is3);
/*  ------------ Subdivide triangle */
	i__2 = nsub - 1;
	for (ii = 0; ii <= i__2; ++ii) {
	    i__3 = ii;
	    for (jj = 0; jj <= i__3; ++jj) {
/*  ------------ Righted triangles */
		for (kk = 1; kk <= 3; ++kk) {
		    tp1[kk - 1] = pp1[kk - 1] + ii * (pp2[kk - 1] - pp1[kk - 
			    1]) / nsub + jj * (pp3[kk - 1] - pp2[kk - 1]) / 
			    nsub;
		    tp2[kk - 1] = pp1[kk - 1] + (ii + 1) * (pp2[kk - 1] - pp1[
			    kk - 1]) / nsub + jj * (pp3[kk - 1] - pp2[kk - 1])
			     / nsub;
/* L6: */
		    tp3[kk - 1] = pp1[kk - 1] + (ii + 1) * (pp2[kk - 1] - pp1[
			    kk - 1]) / nsub + (jj + 1) * (pp3[kk - 1] - pp2[
			    kk - 1]) / nsub;
		}
		trian_(tp1, tp2, tp3, frec, &frec[3]);
		++krec;
		io___27.ciunit = *lunit;
		io___27.cirec = krec;
		s_wdue(&io___27);
		for (nn = 1; nn <= 19; ++nn) {
		    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real))
			    ;
		}
		e_wdue();
		if (ii > 0 && jj < ii) {
/*  ------------ Upside down triangles */
		    for (kk = 1; kk <= 3; ++kk) {
			tp1[kk - 1] = pp1[kk - 1] + ii * (pp2[kk - 1] - pp1[
				kk - 1]) / nsub + jj * (pp3[kk - 1] - pp2[kk 
				- 1]) / nsub;
			tp2[kk - 1] = pp1[kk - 1] + ii * (pp2[kk - 1] - pp1[
				kk - 1]) / nsub + (jj + 1) * (pp3[kk - 1] - 
				pp2[kk - 1]) / nsub;
/* L7: */
			tp3[kk - 1] = pp1[kk - 1] + (ii + 1) * (pp2[kk - 1] - 
				pp1[kk - 1]) / nsub + (jj + 1) * (pp3[kk - 1] 
				- pp2[kk - 1]) / nsub;
		    }
		    trian_(tp1, tp2, tp3, frec, &frec[3]);
		    ++krec;
		    io___28.ciunit = *lunit;
		    io___28.cirec = krec;
		    s_wdue(&io___28);
		    for (nn = 1; nn <= 19; ++nn) {
			do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(
				real));
		    }
		    e_wdue();
		}
/* L8: */
	    }
/* L9: */
	}
/* L10: */
    }
    ibuf[0] = krec - 1;
    io___30.ciunit = *lunit;
    s_wdue(&io___30);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    return 0;
} /* pyrgeo_ */

/* Subroutine */ int trian_(p1, p2, p3, pc, area)
real *p1, *p2, *p3, *pc, *area;
{
    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__;
    static real s, d1, d2, d3;
    extern doublereal dot_();


/*  Triangle in space */

/*  P1, P2, P3  Vertices (input) */
/*  PC          Center of area */
/*  AREA        Area of triangle */

    /* Parameter adjustments */
    --pc;
    --p3;
    --p2;
    --p1;

    /* Function Body */
    d1 = sqrt(dot_(&p1[1], &p2[1]));
    d2 = sqrt(dot_(&p2[1], &p3[1]));
    d3 = sqrt(dot_(&p3[1], &p1[1]));
    s = d1 + d2 + d3;
    *area = sqrt(s * (s - d1) * (s - d2) * (s - d3));
    for (i__ = 1; i__ <= 3; ++i__) {
/* L1: */
	pc[i__] = (p1[i__] + p2[i__] + p3[i__]) / (float)3.;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* trian_ */

