/* RMCCUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__4 = 4;

/* Subroutine */ int rmccur_(w, h__, nm, mm, slanty, slantx, akz, akf, ny, nx,
	 lunit)
real *w, *h__;
integer *nm, *mm;
real *slanty, *slantx, *akz, *akf;
integer *ny, *nx, *lunit;
{
    /* Initialized data */

    static real pi = (float)3.141592654;
    static real cc = (float).2997925;
    static real eps = (float).008854185;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3;
    complex q__1, q__2, q__3;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_wdue(), do_uio(), e_wdue();
    double cos(), sin(), c_abs(), sqrt();
    integer s_rdue(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
    static integer krec;
#define ibuf ((integer *)equiv_0)
    extern doublereal freq_();
    static real cons;
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static real curn;
    static integer i__, j;
    static real x, y;
    static complex quadx, quady;
    static real power;
#define pk (equiv_0 + 2)
    static integer nn;
    static real hx, hy, ss;

    /* Fortran I/O blocks */
    static cilist io___13 = { 0, 0, 0, 0, 1 };
    static cilist io___23 = { 0, 0, 0, 0, 0 };
    static cilist io___25 = { 0, 0, 0, 0, 0 };
    static cilist io___26 = { 0, 0, 0, 0, 0 };



/*  Currents File of Rectangular Waveguide Horn in TM mode */

/*  W       Width of horn aperture along Y axis (m) */
/*  H       Height of horn aperture along X axis (m) */
/*  NM      Mode number along Y axis */
/*  MM      Mode number along X axis */
/*  SLANTY  Slant radius in Y axis plane */
/*  SLANTX  Slant radius in X axis plane */
/*  AKZ     Z-axis propagation constant in waveguide */
/*  AKF     Propagation constant in free space */
/*  NY      Number of points in Y axis (width) integrals */
/*  NX      Number of points in X axis (height) integrals */
/*  LUNIT   Logical unit of random access file for currents */

    hx = *h__ / *nx;
    hy = *w / *ny;
    frec[3] = hx * hy;
    curj[2].r = (float)0., curj[2].i = (float)0.;
    curm[2].r = (float)0., curm[2].i = (float)0.;
    frec[2] = (float)0.;
    cons = *akf * cc * eps;
    power = (float)0.;
    *pk = *akf;
    ibuf[0] = *nx * *ny;
    ibuf[1] = 0;
    io___13.ciunit = *lunit;
    s_wdue(&io___13);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    krec = 1;
/* ------- Loop along Y axis */
    i__1 = *ny;
    for (i__ = 1; i__ <= i__1; ++i__) {
	frec[1] = -(*w) / (float)2. + hy * (i__ - (float).5);
	y = hy * (i__ - (float).5);
/* Computing 2nd power */
	r__1 = frec[1];
	ss = *akf * (r__1 * r__1) / *slanty / (float)2.;
	r__1 = cos(ss);
	r__2 = -sin(ss);
	q__1.r = r__1, q__1.i = r__2;
	quady.r = q__1.r, quady.i = q__1.i;
/* ------- Loop along X axis */
	i__2 = *nx;
	for (j = 1; j <= i__2; ++j) {
	    frec[0] = -(*h__) / (float)2. + hx * (j - (float).5);
	    x = hx * (j - (float).5);
/* Computing 2nd power */
	    r__1 = frec[0];
	    ss = *akf * (r__1 * r__1) / *slantx / (float)2.;
	    r__1 = cos(ss);
	    r__2 = -sin(ss);
	    q__3.r = r__1, q__3.i = r__2;
	    q__2.r = q__3.r * quadx.r - q__3.i * quadx.i, q__2.i = q__3.r * 
		    quadx.i + q__3.i * quadx.r;
	    r__3 = freq_(&c__4);
	    q__1.r = r__3 * q__2.r, q__1.i = r__3 * q__2.i;
	    quadx.r = q__1.r, quadx.i = q__1.i;
	    r__1 = sin(*nm * pi * y / *w) * cos(*mm * pi * x / *h__) * *mm * 
		    pi / *h__;
	    q__1.r = r__1 * quadx.r, q__1.i = r__1 * quadx.i;
	    curj[0].r = q__1.r, curj[0].i = q__1.i;
	    r__1 = *nm * pi / *w * cos(*nm * pi * y / *w) * sin(*mm * pi * x /
		     *h__);
	    q__1.r = r__1 * quadx.r, q__1.i = r__1 * quadx.i;
	    curj[1].r = q__1.r, curj[1].i = q__1.i;
	    r__1 = -(*akz) * *nm * pi / *w * cos(*nm * pi * y / *w) * sin(*mm 
		    * pi * x / *h__);
	    q__2.r = r__1 * quadx.r, q__2.i = r__1 * quadx.i;
	    q__1.r = q__2.r / cons, q__1.i = q__2.i / cons;
	    curm[0].r = q__1.r, curm[0].i = q__1.i;
	    r__1 = -(*akz) * *mm * pi / *h__ * sin(*nm * pi * y / *w) * cos(*
		    mm * pi * x / *h__);
	    q__2.r = r__1 * quadx.r, q__2.i = r__1 * quadx.i;
	    q__1.r = q__2.r / cons, q__1.i = q__2.i / cons;
	    curm[1].r = q__1.r, curm[1].i = q__1.i;
	    ++krec;
	    io___23.ciunit = *lunit;
	    io___23.cirec = krec;
	    s_wdue(&io___23);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
/* L1: */
	    q__1.r = curm[0].r * curj[1].r - curm[0].i * curj[1].i, q__1.i = 
		    curm[0].r * curj[1].i + curm[0].i * curj[1].r;
	    q__2.r = curm[1].r * curj[0].r - curm[1].i * curj[0].i, q__2.i = 
		    curm[1].r * curj[0].i + curm[1].i * curj[0].r;
	    power += (c_abs(&q__1) + c_abs(&q__2)) / freq_(&c__4);
	}
    }
    curn = sqrt(power);
    i__2 = krec;
    for (i__ = 2; i__ <= i__2; ++i__) {
	io___25.ciunit = *lunit;
	io___25.cirec = i__;
	s_rdue(&io___25);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
	    i__1 = j - 1;
	    i__3 = j - 1;
	    q__1.r = curj[i__3].r / curn, q__1.i = curj[i__3].i / curn;
	    curj[i__1].r = q__1.r, curj[i__1].i = q__1.i;
/* L2: */
	    i__1 = j - 1;
	    i__3 = j - 1;
	    q__1.r = curm[i__3].r / curn, q__1.i = curm[i__3].i / curn;
	    curm[i__1].r = q__1.r, curm[i__1].i = q__1.i;
	}
/* L3: */
	io___26.ciunit = *lunit;
	io___26.cirec = i__;
	s_wdue(&io___26);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rmccur_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


