/* SCACOM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Subroutine */ int scacom_(power, phase)
real *power, *phase;
{
    /* Initialized data */

    static real tr = (float).01745329;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;
    complex q__1, q__2;

    /* Builtin functions */
    double sqrt(), cos(), sin();

    /* Local variables */
    extern doublereal curj_(), curm_();
    static integer i__, j;
    static complex cv;


/*  Scales currents in common */

/*  POWER  Power (watts) of currents in common */
/*  PHASE  Phase (degrees) */

    r__1 = sqrt(*power);
    r__2 = cos(*phase * tr);
    r__3 = sin(*phase * tr);
    q__2.r = r__2, q__2.i = r__3;
    q__1.r = r__1 * q__2.r, q__1.i = r__1 * q__2.i;
    cv.r = q__1.r, cv.i = q__1.i;
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    i__2 = j + i__ * 3 - 4;
	    r__1 = curj_(&j);
	    q__1.r = r__1 * cv.r, q__1.i = r__1 * cv.i;
	    currenj_1.curja[i__2].r = q__1.r, currenj_1.curja[i__2].i = 
		    q__1.i;
/* L1: */
	    i__2 = j + i__ * 3 - 4;
	    r__1 = curm_(&j);
	    q__1.r = r__1 * cv.r, q__1.i = r__1 * cv.i;
	    currenm_1.curma[i__2].r = q__1.r, currenm_1.curma[i__2].i = 
		    q__1.i;
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* scacom_ */

