/* SPGAIN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__22 = 22;
static integer c__3 = 3;

doublereal spgain_(w)
real *w;
{
    /* Initialized data */

    static real wid[22] = { (float).1,(float).12,(float).14,(float).16,(float)
	    .18,(float).2,(float).22,(float).24,(float).26,(float).28,(float)
	    .3,(float).32,(float).34,(float).36,(float).38,(float).4,(float)
	    .42,(float).44,(float).46,(float).48,(float).5,(float).52 };
    static real zr[22] = { (float)111.6,(float)93.759,(float)81.13,(float)
	    71.755,(float)64.546,(float)58.848,(float)54.246,(float)50.458,(
	    float)47.292,(float)44.606,(float)42.296,(float)40.283,(float)
	    38.504,(float)36.911,(float)35.464,(float)34.131,(float)32.885,(
	    float)31.707,(float)30.579,(float)29.49,(float)28.431,(float)
	    27.398 };
    static real pi = (float)3.14159265;
    static real zzo = (float)376.73;

    /* System generated locals */
    real ret_val, r__1;

    /* Builtin functions */
    double r_lg10();

    /* Local variables */
    static real gain;
    extern doublereal alinp_();
    static real zz;


/*  Square Patch Gain dB: W width in wavelengths */

    zz = alinp_(w, wid, zr, &c__22, &c__3);
/* Computing 2nd power */
    r__1 = zz * *w;
    gain = pi * (float)4. / zzo * (r__1 * r__1);
    ret_val = r_lg10(&gain) * (float)10.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* spgain_ */

