/* ZRES.F -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int zres_(z__, zs, zl, r__, ra, trans, ta, zin)
complex *z__, *zs, *zl;
real *r__, *ra, *trans, *ta;
complex *zin;
{
    /* System generated locals */
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7;

    /* Builtin functions */
    void c_div();
    double c_abs(), r_imag(), atan2(), r_lg10();

    /* Local variables */
    static complex b1;


/*  Response of Z matrix */

/*  Z(4)    2 x 2 Z matrix */
/*  ZS, ZL  Source, Load impedances */
/*  R	   Reflection coefficient magnitude */
/*  RA	   Reflection coefficient phase (deg) */
/*  TRANS   Transmission dB */
/*  TA	   Transmission phase (deg) */
/*  ZIN	   Input impedance */

    /* Parameter adjustments */
    --z__;

    /* Function Body */
    q__3.r = z__[2].r * z__[3].r - z__[2].i * z__[3].i, q__3.i = z__[2].r * 
	    z__[3].i + z__[2].i * z__[3].r;
    q__4.r = zl->r + z__[4].r, q__4.i = zl->i + z__[4].i;
    c_div(&q__2, &q__3, &q__4);
    q__1.r = z__[1].r - q__2.r, q__1.i = z__[1].i - q__2.i;
    zin->r = q__1.r, zin->i = q__1.i;
    q__2.r = zin->r - zs->r, q__2.i = zin->i - zs->i;
    q__3.r = zin->r + zs->r, q__3.i = zin->i + zs->i;
    c_div(&q__1, &q__2, &q__3);
    b1.r = q__1.r, b1.i = q__1.i;
    *r__ = c_abs(&b1);
    *ra = atan2(r_imag(&b1), b1.r) * (float)57.29578;
    q__2.r = zl->r * z__[3].r - zl->i * z__[3].i, q__2.i = zl->r * z__[3].i + 
	    zl->i * z__[3].r;
    q__5.r = z__[1].r + zs->r, q__5.i = z__[1].i + zs->i;
    q__6.r = z__[4].r + zl->r, q__6.i = z__[4].i + zl->i;
    q__4.r = q__5.r * q__6.r - q__5.i * q__6.i, q__4.i = q__5.r * q__6.i + 
	    q__5.i * q__6.r;
    q__7.r = z__[2].r * z__[3].r - z__[2].i * z__[3].i, q__7.i = z__[2].r * 
	    z__[3].i + z__[2].i * z__[3].r;
    q__3.r = q__4.r - q__7.r, q__3.i = q__4.i - q__7.i;
    c_div(&q__1, &q__2, &q__3);
    b1.r = q__1.r, b1.i = q__1.i;
    *ta = atan2(r_imag(&b1), b1.r) * (float)57.29578;
    c_div(&q__1, &b1, zl);
/* Computing 2nd power */
    r__2 = c_abs(&q__1);
    r__1 = zs->r * (float)4. * zl->r * (r__2 * r__2);
    *trans = r_lg10(&r__1) * (float)10.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* zres_ */

