      SUBROUTINE ARADS(S,AR)
C 
C  Unit Vector in Radius Direction (Rectangular Coordinates)
C 
C  S - Spherical Coordinates
C  AR - Unit Vector 
C 
      DIMENSION S(1),AR(1)
      AR(1)=SIN(S(2))*COS(S(3)) 
      AR(2)=SIN(S(2))*SIN(S(3)) 
      AR(3)=COS(S(2)) 
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END 
