      FUNCTION DSKBLF(XB,XS,VR)
C
C  Disk blockage function for far field
C
C  XB(1)  X position of disk center
C     2   Y position of disk center
C     3   Z position of disk center
C     4   Radius of disk
C     5   Unit normal to disk (X component)
C     6   Unit normal to disk (Y component)
C     7   Unit normal to disk (Z component)
C  XS     Source point
C  VR     Radial unit vector
C
      DIMENSION XB(1),XS(1),VR(1),P(3)
      DSKBLF=0.
      CALL PINTS(XS,VR,XB(1),XB(5),T,P,NIS)
      IF(NIS.EQ.-1)RETURN
      DIST=SQRT((P(1)-XB(1))**2+(P(2)-XB(2))**2+(P(3)-XB(3))**2)
      IF(DIST.GT.XB(4).OR.T.LT.0)RETURN
      DSKBLF=1
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
