      SUBROUTINE GEOROT(LUNIT,ROT,CENT,TRANSL)
C
C  Rotation of Geometry in File about point in space
C
C  LUNIT      Logical unit of currents and geometry file
C  ROT(3,3)   Rotation matrix
C  CENT(3)    Center of rotation
C  TRANSL(3)  Translation after rotation
C
      DIMENSION ROT(3,3),CENT(3),TRANSL(3),XC(3),XA(3),FREC(19),UN(3)
      INTEGER*4 IBUF(19)
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C  ---------- Loop on points
      DO 3 K=1,IBUF(1)
      READ(LUNIT,REC=K+1)(FREC(NN),NN=1,19)
C  ---------- Point relative to center of rotation
      DO 1 J=1,3
    1 XC(J)=FREC(J)-CENT(J)
C  ---------- Rotate position
      CALL MTMULT(XC,ROT,XA,1,3,3)
C  ---------- Rotate unit vector
      CALL MTMULT(FREC(5),ROT,UN,1,3,3)
      DO 2 J=1,3
      FREC(J)=XA(J)+CENT(J)+TRANSL(J)
    2 FREC(J+4)=UN(J)
    3 WRITE(LUNIT,REC=K+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
