      SUBROUTINE POLBKP(VT,NV,CT,ROT,XB)
C
C  Polygon Disk Blockage Preparation
C
C  VT(3,NV)   Vertices of polygon ordered CCW around Normal (in
C             X-Y plane)
C  NV         Number of vertices
C  CT(3)      Center of poylgon after rotation
C  ROT(3,3)   Rotation matrix (polygon rotated off X-Y plane)
C  XB         Blockage function vector
C      1      Number of vertices
C      2 - 4  Unit normal
C      5 -    Vertices
C
      DIMENSION VT(1),CT(1),ROT(3,3),XB(1),AN(3)
      XB(1)=NV
      CALL POLYNM(VT,AN)
      CALL MTMULT(AN,ROT,XB(2),1,3,3)
      DO 1 I=1,NV
      K=3*(I-1)+1
      KK=3*(I-1)+5
      CALL MTMULT(VT(K),ROT,XB(KK),1,3,3)
    1 CALL VLINC(1.,XB(KK),1.,CT,XB(KK))
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
