      SUBROUTINE RETSP(X,S)
C 
C  Rectangular to Spherical Coordinates 
C  X - (X,Y,Z)
C  S - Radius, Theta (radians), Phi (radians) 
C 
      DIMENSION S(3),X(3) 
      PI=2.*ACOS(0.)
      S(1)=SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3))
      S(2)=0. 
      S(3)=0. 
      IF(S(1).LE.0.)RETURN
      S(2)=ACOS(X(3)/S(1))
      IF(S(2).EQ.0.OR.S(2).EQ.PI)RETURN 
      S(3)=ATAN2(X(2),X(1)) 
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END 
