      SUBROUTINE SCACOM(POWER,PHASE)
C
C  Scales currents in common
C
C  POWER  Power (watts) of currents in common
C  PHASE  Phase (degrees)
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      COMPLEX CURJA,CURMA,CV
      DATA TR/.01745329/
      CV=SQRT(POWER)*CMPLX(COS(PHASE*TR),SIN(PHASE*TR))
      DO 2 I=1,NCUR
      DO 1 J=1,3
      CURJA(J,I)=CURJ(J)*CV
    1 CURMA(J,I)=CURM(J)*CV
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
