      SUBROUTINE SPHCUR(PKC,BLOCK,XB,LUNIT)
C
C  Adds Currents on Sphere using SPHGEO geometry file
C
C  PKC     Propagation constant
C  LUNIT   Logical unit of random access file for currents
C
      COMPLEX CURJ(3),CURM(3),EFIELD(3),HFIELD(3),UNIT(3)
      DIMENSION FREC(19),XC(3),XB(1)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      DATA XC/0.,0.,0./
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=0
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 2 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      CALL NFPATR(XC,BLOCK,XB,FREC,EFIELD,HFIELD)
      DO 1 J=1,3
    1 UNIT(J)=FREC(J+4)*FREC(4)
      CALL CCROSS(UNIT,HFIELD,CURJ)
      CALL CCROSS(EFIELD,UNIT,CURM)
    2 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
