function v = cross0l(v1,v2)

% cross product operation function
%
% v1 and v2 and v are N by 3 vectors of N triplets: the 
% x, y, and z component values
%   

v(:,1)=(v1(:,2).*v2(:,3))-(v1(:,3).*v2(:,2));
v(:,2)=(v1(:,3).*v2(:,1))-(v1(:,1).*v2(:,3));
v(:,3)=(v1(:,1).*v2(:,2))-(v1(:,2).*v2(:,1));

%

