% MATLAB script file for calculating far-field 
% patterns of vector electric point source inside
% spherical equivalent surface.
% 
% PART b: calculates the equivalent currents
% Expected previous files: po6a
%

Hs=-propnf01(rs,Js,req,k0);	% source H field
Es=-Z0*cross01(uneq,Hs);	% source E field
Jeq=cross01(uneq,Hs);		% eq electric current 
Meq=-cross01(uneq,Es);		% eq magnetic current


Mn=Meq.*(dSeq*ones(1,3));	% normalized current
Jn=Jeq.*(dSeq*ones(1,3)); 	% normalized current

%