/* CONEGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)1.;
static real c_b3 = (float)-1.;
static integer c__1 = 1;
static integer c__3 = 3;

/* Subroutine */ int conegeo_(p1, p2, rad1, rad2, alinc, lunit, icat)
real *p1, *p2, *rad1, *rad2, *alinc;
integer *lunit, *icat;
{
    /* Initialized data */

    static real pi = (float)3.141592654;
    static integer ia[3] = { 3,2,3 };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double atan(), cos();
    integer s_rdue(), do_uio(), e_rdue();
    double tan(), sin();
    integer s_wdue(), e_wdue();

    /* Local variables */
    static real ainc, frec[19], alen;
    static integer krec, ibuf[19];
    static real axis[3];
    static integer i__, j;
    static real angle;
    extern /* Subroutine */ int vlinc_(), euler_(), retsp_();
    static real z1, z2, eu[3];
    static integer nl, nn, np;
    static real sp[3], radius;
    extern /* Subroutine */ int mtmult_();
    static real ang, vec[3], pos[3], rot[9]	/* was [3][3] */;

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 0, 0, 0, 1 };
    static cilist io___25 = { 0, 0, 0, 0, 0 };
    static cilist io___26 = { 0, 0, 0, 0, 1 };



/*  Geometry file of Truncated Cone */

/*  P1(3)      Starting point of cone (m) */
/*  P2(3)      End point of axis  (m) */
/*  RAD1       Radius of cone at point P1 */
/*  RAD2       Radius of cone at point P2 */
/*  ALINC      Current patch increment (m) */
/*  LUNIT      Logical unit of disk file */
/*  ICAT       If 1, concatenate */

    /* Parameter adjustments */
    --p2;
    --p1;

    /* Function Body */
    vlinc_(&c_b2, &p2[1], &c_b3, &p1[1], axis);
    retsp_(axis, sp);
    angle = atan((*rad2 - *rad1) / sp[0]);
/*  ------------ Find axis increment: ALEN */
    nl = sp[0] / *alinc / cos(angle) + (float).5;
    alen = sp[0] / nl;
/*  ------------ Find rotation matrix */
    eu[0] = sp[2];
    eu[1] = sp[1];
    eu[2] = (float)0.;
    euler_(eu, ia, rot);
/*  ------------ Layout cone along Z-axis */
    if (*icat == 1) {
	io___10.ciunit = *lunit;
	s_rdue(&io___10);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
	}
	e_rdue();
	krec = ibuf[0] + 1;
    } else {
	krec = 1;
    }
    i__1 = nl;
    for (i__ = 1; i__ <= i__1; ++i__) {
	pos[2] = (i__ - (float).5) * alen;
	z2 = i__ * alen;
	z1 = (i__ - 1) * alen;
	radius = *rad1 + pos[2] * (*rad2 - *rad1) / sp[0];
	np = pi * (float)2. * radius / *alinc + (float).5;
	np /= 4;
	np = np + 1 << 2;
	ainc = pi * (float)2. / np;
/*  ------------ Find patch area */
/* Computing 2nd power */
	r__1 = z2;
/* Computing 2nd power */
	r__2 = z1;
	frec[3] = ainc * (*rad1 * alen + (r__1 * r__1 - r__2 * r__2) * (float)
		.5 * tan(angle)) / cos(angle);
	i__2 = np;
	for (j = 1; j <= i__2; ++j) {
	    ang = (j - 1) * ainc;
/*  ------------ Find position */
	    pos[0] = radius * cos(ang);
	    pos[1] = radius * sin(ang);
	    mtmult_(pos, rot, vec, &c__1, &c__3, &c__3);
	    vlinc_(&c_b2, vec, &c_b2, &p1[1], frec);
/*  ------------ Find normal vector */
	    vec[0] = cos(ang) * cos(angle);
	    vec[1] = sin(ang) * cos(angle);
	    vec[2] = -sin(angle);
	    mtmult_(vec, rot, &frec[4], &c__1, &c__3, &c__3);
	    ++krec;
/* L1: */
	    io___25.ciunit = *lunit;
	    io___25.cirec = krec;
	    s_wdue(&io___25);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    io___26.ciunit = *lunit;
    s_wdue(&io___26);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* conegeo_ */

