/* CPGAIN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__25 = 25;
static integer c__3 = 3;

doublereal cpgain_(rad)
real *rad;
{
    /* Initialized data */

    static real rrd[25] = { (float).06,(float).07,(float).08,(float).09,(
	    float).1,(float).11,(float).12,(float).13,(float).14,(float).15,(
	    float).16,(float).17,(float).18,(float).19,(float).2,(float).21,(
	    float).22,(float).23,(float).24,(float).25,(float).26,(float).27,(
	    float).28,(float).29,(float).3 };
    static real zr[25] = { (float)103.56,(float)89.684,(float)79.408,(float)
	    71.539,(float)65.358,(float)60.408,(float)56.386,(float)53.081,(
	    float)50.343,(float)48.061,(float)46.154,(float)44.557,(float)
	    43.22,(float)42.103,(float)41.173,(float)40.401,(float)39.762,(
	    float)39.234,(float)38.794,(float)38.421,(float)38.093,(float)
	    37.789,(float)37.487,(float)37.163,(float)36.796 };
    static real pi = (float)3.14159265;
    static real zzo = (float)376.73;

    /* System generated locals */
    real ret_val, r__1;

    /* Builtin functions */
    double r_lg10();

    /* Local variables */
    static real gain;
    extern doublereal alinp_();
    static real zz;


/*  Circular Patch Gain dB: RAD Radius in wavelengths */

    zz = alinp_(rad, rrd, zr, &c__25, &c__3);
/* Computing 2nd power */
    r__1 = pi * *rad * zz;
    gain = pi / zzo * (r__1 * r__1);
    ret_val = r_lg10(&gain) * (float)10.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* cpgain_ */

