/* durgeo.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int durgeo_(dmain, dsub, fod, fed, type__, a, b, cent, feed)
real *dmain, *dsub, *fod, *fed, *type__, *a, *b, *cent, *feed;
{
    /* System generated locals */
    real r__1, r__2, r__3;

    /* Builtin functions */
    double atan(), cos(), sin(), sqrt();

    /* Local variables */
    static real amag, phio, e, p, focus, tc, pz, tho;


/*  Dual Reflector Geometry */

/*  DMAIN    Diameter of main reflector */
/*  DSUB     Diameter of subreflector */
/*  FOD      Main reflector f/D */
/*  FED      Effective f/D of dual reflector system */
/*  TYPE     1) Hyperboloid (Cassegrain), 2) Ellipsoid (Gregorian) */

/*  A	    Z-axis factor of subreflector curve */
/*  B	    Radial factor of subreflector curve */
/*  CENT(3)  Location of center of subreflector geometry */
/*  FFED(3)  Location of feed */

    /* Parameter adjustments */
    --feed;
    --cent;

    /* Function Body */
    amag = *fed / *fod;
    e = (amag + (float)1.) / (amag - (float)1.);
    if (*type__ == (float)2.) {
	e = (float)1. / e;
    }
/* -------- Half subtended of main and subreflector at focus & feed */
    phio = atan((float)1. / (*fod * (float)4.)) * (float)2.;
    tho = atan((float)1. / (*fed * (float)4.)) * (float)2.;
    if (*type__ == (float)1.) {
	pz = e * (float)2. * e / (e * e - (float)1.);
	p = *dsub * (e * cos(tho) - (float)1.) / (e * (float)2. * sin(tho));
    } else if (*type__ == (float)2.) {
	pz = e * (float)2. * e / ((float)1. - e * e);
	p = -(*dsub) * (e * cos(tho) - (float)1.) / (e * (float)2. * sin(tho))
		;
    }
/* -------- Subreflector parameters 2*C, A, and B */
    tc = pz * p;
    *a = tc / (float)2. / e;
/* Computing 2nd power */
    r__2 = tc / (float)2.;
/* Computing 2nd power */
    r__3 = *a;
    *b = sqrt((r__1 = r__2 * r__2 - r__3 * r__3, dabs(r__1)));
    focus = *fod * *dmain;
    feed[1] = (float)0.;
    feed[2] = (float)0.;
    feed[3] = focus - tc;
    cent[1] = (float)0.;
    cent[2] = (float)0.;
    cent[3] = focus - tc / (float)2.;
    return 0;
} /* durgeo_ */

