/* FILROT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;

/* Subroutine */ int filrot_(lunit, rot, cent)
integer *lunit;
real *rot, *cent;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static integer j, k;
    extern doublereal curma_();
    static complex curjo[3], curmo[3];
    static real xa[3], xc[3];
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int cvtrot_(), mtmult_();

    /* Fortran I/O blocks */
    static cilist io___6 = { 0, 0, 0, 0, 1 };
    static cilist io___9 = { 0, 0, 0, 0, 0 };
    static cilist io___15 = { 0, 0, 0, 0, 0 };



/*  Rotation of Currents in File about point in space */

/*  LUNIT      Logical unit of currents and geometry file */
/*  ROT(3,3)   Rotation matrix */
/*  CENT(3)    Center of rotation */

    /* Parameter adjustments */
    --cent;
    rot -= 4;

    /* Function Body */
    io___6.ciunit = *lunit;
    s_rdue(&io___6);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    i__1 = ibuf[0];
    for (k = 1; k <= i__1; ++k) {
	io___9.ciunit = *lunit;
	io___9.cirec = k + 1;
	s_rdue(&io___9);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
/*  ------------ Rotate point */
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    xc[j - 1] = frec[j - 1] - cent[j];
	}
	mtmult_(xc, &rot[4], xa, &c__1, &c__3, &c__3);
/*  ------------ Rotate currents */
	cvtrot_(curj, &rot[4], curjo);
	cvtrot_(curm, &rot[4], curmo);
	for (j = 1; j <= 3; ++j) {
	    xc[j - 1] = frec[j + 3];
	    frec[j - 1] = xa[j - 1] + cent[j];
	    i__2 = j - 1;
	    i__3 = j - 1;
	    curj[i__2].r = curjo[i__3].r, curj[i__2].i = curjo[i__3].i;
/* L2: */
	    i__2 = j - 1;
	    r__1 = curma_(&j);
	    curm[i__2].r = r__1, curm[i__2].i = (float)0.;
	}
/*  ------------ Rotate normal */
	mtmult_(xc, &rot[4], &frec[4], &c__1, &c__3, &c__3);
/* L3: */
	io___15.ciunit = *lunit;
	io___15.cirec = k + 1;
	s_wdue(&io___15);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* filrot_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


