/* NFPATF.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int nfpatf_(lunit, xc, block, xb, xf, efield, hfield)
integer *lunit;
real *xc;
doublereal (*block) ();
real *xb, *xf;
complex *efield, *hfield;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;
    static real eps = (float).008854185;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1;
    complex q__1, q__2;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
    static complex conj, conm;
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static integer ncur, i__, j;
    extern /* Subroutine */ int grejc_(), grhjc_();
    static integer nctyp;
    static complex ef[3], hf[3];
#define pk (equiv_0)
    static integer nn;
    static real xs[3];
    extern /* Subroutine */ int cmtmul_();
    static complex gej[9]	/* was [3][3] */, ghj[9]	/* was [3][3] 
	    */;

    /* Fortran I/O blocks */
    static cilist io___9 = { 0, 0, 0, 0, 1 };
    static cilist io___16 = { 0, 0, 0, 0, 0 };



/*  Near field pattern from currents in file */

/*  LUNIT     Logical unit of open file */
/*  XC(3)     Position of center of currents */
/*  BLOCK     Blockage function (external) = 1 when blocked */
/*  XB        Array of variables for blockage function */
/*  XF(3)     Field point (meters) */
/*  EFIELD    Electric field (V/m) */
/*  HFIELD    Magnetic field */

    /* Parameter adjustments */
    --hfield;
    --efield;
    --xf;
    --xb;
    --xc;

    /* Function Body */
    io___9.ciunit = *lunit;
    s_rdue(&io___9);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
/* ------------- -j*2*Pi*Frequency*Mu  ------ electric field factor */
    r__1 = -(*pk) * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
/* ------------- -j*2*Pi*Frequency*epsilon -- magnetic field factor */
    r__1 = -(*pk) * cc * eps;
    q__1.r = (float)0., q__1.i = r__1;
    conm.r = q__1.r, conm.i = q__1.i;
    ncur = ibuf[0];
    nctyp = ibuf[1];
    for (i__ = 1; i__ <= 3; ++i__) {
	i__1 = i__;
	efield[i__1].r = (float)0., efield[i__1].i = (float)0.;
/* L1: */
	i__1 = i__;
	hfield[i__1].r = (float)0., hfield[i__1].i = (float)0.;
    }
/* --------- Loop on current patches */
    i__1 = ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___16.ciunit = *lunit;
	io___16.cirec = i__ + 1;
	s_rdue(&io___16);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
/* L2: */
	    xs[j - 1] = frec[j - 1] + xc[j];
	}
/* --------- Check for blockage */
	if ((*block)(&xb[1], xs, &xf[1]) == (float)0.) {
	    grejc_(&xf[1], xs, pk, gej);
	    grhjc_(&xf[1], xs, pk, ghj);
	    if (nctyp < 2) {
/* --------- Electric currents available */
		cmtmul_(gej, curj, ef);
		cmtmul_(ghj, curj, hf);
		for (j = 1; j <= 3; ++j) {
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__1.r = hfield[i__3].r + hf[i__4].r, q__1.i = hfield[
			    i__3].i + hf[i__4].i;
		    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
/* L3: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__2.r = ef[i__4].r * conj.r - ef[i__4].i * conj.i, 
			    q__2.i = ef[i__4].r * conj.i + ef[i__4].i * 
			    conj.r;
		    q__1.r = efield[i__3].r + q__2.r, q__1.i = efield[i__3].i 
			    + q__2.i;
		    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
		}
	    }
	    if (nctyp != 1) {
/* --------- Magnetic currents available */
		cmtmul_(gej, curm, hf);
		cmtmul_(ghj, curm, ef);
		for (j = 1; j <= 3; ++j) {
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__1.r = efield[i__3].r - ef[i__4].r, q__1.i = efield[
			    i__3].i - ef[i__4].i;
		    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
/* L4: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__2.r = hf[i__4].r * conm.r - hf[i__4].i * conm.i, 
			    q__2.i = hf[i__4].r * conm.i + hf[i__4].i * 
			    conm.r;
		    q__1.r = hfield[i__3].r + q__2.r, q__1.i = hfield[i__3].i 
			    + q__2.i;
		    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
		}
	    }
	}
/* L5: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* nfpatf_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


