/* PARGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b4 = (float)1.;
static integer c__1 = 1;

/* Subroutine */ int pargeo_(dia, focus, offset, vp, alinc, lunit)
real *dia, *focus, *offset, *vp, *alinc;
integer *lunit;
{
    /* Initialized data */

    static real pi = (float)3.14159654;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double cos(), sin(), sqrt();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real area, frec[19];
    static integer krec, ibuf[19], i__, j;
    extern /* Subroutine */ int vlinc_(), normp_();
    static real r1, r2, hp, hr, ph;
    static integer nn, np;
    static real pp[3];
    static integer nr;
    static real rp, rad;

    /* Fortran I/O blocks */
    static cilist io___17 = { 0, 0, 0, 0, 0 };
    static cilist io___20 = { 0, 0, 0, 0, 1 };



/*  Offset Paraboloidal Reflector Geometry for Currents File */
/*  Polar Grid */

/*  DIA     Diameter of projected reflector */
/*  FOCUS   Focal length */
/*  OFFSET  Offset (center of circular aperture in X-Y plane) */
/*  VP(3)   Location of parent paraboloid vertex */
/*  ALINC   Length increment in aperture plane for current patches */
/*  Note:   Paraboloid axis along Z-axis */
/*  LUNIT   Logical unit of random access file for currents */

    /* Parameter adjustments */
    --vp;
    --offset;

    /* Function Body */
    nr = *dia / *alinc / (float)2. + (float).5;
    hr = *dia / (float)2. / nr;
    krec = 1;
/*  ------------- Loop over radius */
    i__1 = nr;
    for (j = 1; j <= i__1; ++j) {
	rad = ((real) (j - 1) + (float).5) * hr;
/*  ------------- Find differential area on aperture plane */
	r1 = rad - hr / (float)2.;
	r2 = rad + hr / (float)2.;
/* Computing 2nd power */
	r__1 = r2;
/* Computing 2nd power */
	r__2 = r1;
	area = (r__1 * r__1 - r__2 * r__2) / (float)2.;
	np = pi * (float)2. * rad / *alinc + (float).5;
	np /= 4;
	np = np + 1 << 2;
	hp = pi * (float)2. / np;
/*  ------------- Loop over Phi */
	i__2 = np;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ph = (real) (i__ - 1) * hp;
	    pp[0] = offset[1] + rad * cos(ph);
	    pp[1] = offset[2] + rad * sin(ph);
/* Computing 2nd power */
	    r__1 = pp[0];
/* Computing 2nd power */
	    r__2 = pp[1];
	    rp = sqrt(r__1 * r__1 + r__2 * r__2);
	    pp[2] = rp * rp / (float)4. / *focus;
/*  ------------- Find unit normal */
	    normp_(pp, focus, &frec[4]);
/*  ------------- Adjust area */
	    frec[3] = area * hp / frec[6];
	    vlinc_(&c_b4, &vp[1], &c_b4, pp, frec);
	    ++krec;
/* L1: */
	    io___17.ciunit = *lunit;
	    io___17.cirec = krec;
	    s_wdue(&io___17);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 1;
    io___20.ciunit = *lunit;
    s_wdue(&io___20);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* pargeo_ */

