/* PINTS.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int pints_(pl, ul, pp, pn, t, p, nis)
real *pl, *ul, *pp, *pn, *t, *p;
integer *nis;
{
    static integer i__;
    extern doublereal dot_();


/*  Intersection of Unbounded plane and line expressed as point and */
/*  unit vector */

/*  PL(3)   Input point on line */
/*  UL(3)   Input unit vector direction of line */
/*  PP(3)   Input Point on plane */
/*  PN(3)   Input unit vector normal to plane */
/*  T       Output distance from point PL to plane */
/*  P(3)    Output intersection point */
/*  NIS     Output = -1 if no intersection */

    /* Parameter adjustments */
    --p;
    --pn;
    --pp;
    --ul;
    --pl;

    /* Function Body */
    if (dot_(&pn[1], &ul[1]) != (float)0.) {
	*nis = 1;
	*t = (dot_(&pn[1], &pp[1]) - dot_(&pn[1], &pl[1])) / dot_(&pn[1], &ul[
		1]);
	for (i__ = 1; i__ <= 3; ++i__) {
/* L1: */
	    p[i__] = pl[i__] + *t * ul[i__];
	}
    } else {
	*nis = -1;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* pints_ */

