/* PLBGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b4 = (float)1.;
static integer c__1 = 1;

/* Subroutine */ int plbgeo_(xmin, xmax, ymin, ymax, block, xb, vp, nx, ny, 
	lunit)
real *xmin, *xmax, *ymin, *ymax;
doublereal (*block) ();
real *xb, *vp;
integer *nx, *ny, *lunit;
{
    /* Initialized data */

    static real vr[3] = { (float)0.,(float)0.,(float)1. };

    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real frec[19];
    static integer krec, ibuf[19], i__, j;
    extern /* Subroutine */ int vlinc_();
    static integer nn;
    static real pp[3], hx, hy;

    /* Fortran I/O blocks */
    static cilist io___9 = { 0, 0, 0, 0, 0 };
    static cilist io___12 = { 0, 0, 0, 0, 1 };



/*  Flat Plate Geometry for Currents File */
/*  using rectangular grid and external blockage function for rim */

/*  XMIN    Minimum X axis position of rim */
/*  XMAX    Maximum X axis position of rim */
/*  YMIN    Minimum Y axis position of rim */
/*  YMAX    Maximum Y axis position of rim */
/*  BLOCK   External blockage function to determine rim shape */
/*  XB( )   Blockage function variables */
/*  VP(3)   Location of center */
/*  Note:   Normal along Z-axis */
/*  NX      Number of points in X-axis integrals */
/*  NY      Number of points in Y-axis integrals */
/*  LUNIT   Logical unit of random access file for currents */

    /* Parameter adjustments */
    --vp;
    --xb;

    /* Function Body */
    hx = (*xmax - *xmin) / *nx;
    hy = (*ymax - *ymin) / *ny;
    frec[3] = hx * hy;
    frec[4] = (float)0.;
    frec[5] = (float)0.;
    frec[6] = (float)1.;
    krec = 1;
/*  ------------- Loop over X-axis */
    i__1 = *nx;
    for (j = 1; j <= i__1; ++j) {
	pp[0] = *xmin + hx * (j - (float).5);
	i__2 = *ny;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    pp[1] = *ymin + hy * (i__ - (float).5);
	    pp[2] = (float)-1.;
	    if ((*block)(&xb[1], pp, vr) == (float)1.) {
/*  ------------- Point within rim */
		pp[2] = (float)0.;
		vlinc_(&c_b4, &vp[1], &c_b4, pp, frec);
		++krec;
		io___9.ciunit = *lunit;
		io___9.cirec = krec;
		s_wdue(&io___9);
		for (nn = 1; nn <= 19; ++nn) {
		    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real))
			    ;
		}
		e_wdue();
	    }
/* L1: */
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 1;
    io___12.ciunit = *lunit;
    s_wdue(&io___12);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* plbgeo_ */

