/* POLBKF.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal polbkf_(xb, xs, vr)
real *xb, *xs, *vr;
{
    /* System generated locals */
    real ret_val;

    /* Local variables */
    static real t;
    extern /* Subroutine */ int pints_();
    static real pt[3];
    static integer nv;
    extern doublereal polyin_();
    static integer nis;


/*  Polygon disk blockage function for far field */

/*  XB         Blockage function vector */
/*      1      Number of vertices */
/*      2 - 4  Unit normal */
/*      5 -    Vertices */

/*  XS(3)      Source point */
/*  VR(3)      Radial unit vector */

    /* Parameter adjustments */
    --vr;
    --xs;
    --xb;

    /* Function Body */
    ret_val = (float)0.;
    nv = xb[1];
    pints_(&xs[1], &vr[1], &xb[5], &xb[2], &t, pt, &nis);
    if (nis == -1 || t < (float)0.) {
	return ret_val;
    }
    if (polyin_(pt, &xb[5], &nv, &xb[2]) == (float)-1.) {
	return ret_val;
    }
    ret_val = (float)1.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* polbkf_ */

