/* RFSCUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int rfscur_(xfd, pkc, lunit, iadd)
real *xfd, *pkc;
integer *lunit, *iadd;
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1;
    complex q__1;
    static real equiv_1[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_1)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static complex unit[3];
    static integer i__, j;
    static complex efield[3];
    static real xb[4];
    static complex hfield[3];
#define pk (equiv_1 + 2)
    static integer nn;
    extern /* Subroutine */ int shadow_();
    extern /* Subroutine */ int nfpatr_(), ccross_();

    /* Fortran I/O blocks */
    static cilist io___6 = { 0, 0, 0, 0, 1 };
    static cilist io___8 = { 0, 0, 0, 0, 1 };
    static cilist io___10 = { 0, 0, 0, 0, 0 };
    static cilist io___16 = { 0, 0, 0, 0, 0 };



/*  Reflector surface currents added to Geometry File */
/*  using Current Common - Shadow only normal toward current included */

/*  XFD(3)   Location of feed - Assumes currents centered on feed */
/*  PKC      Propagation constant */
/*  LUNIT    Logical unit of random access currents file */
/*  IADD     If 1, add to existing currents */

/*  The routine assumes that the currents in common have been rotated */
/*  to the proper orientation to point at the reflector; see FILROT */

    /* Parameter adjustments */
    --xfd;

    /* Function Body */
    io___6.ciunit = *lunit;
    s_rdue(&io___6);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    ibuf[1] = 1;
    *pk = *pkc;
    io___8.ciunit = *lunit;
    s_wdue(&io___8);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    i__1 = ibuf[0];
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___10.ciunit = *lunit;
	io___10.cirec = i__ + 1;
	s_rdue(&io___10);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    xb[j - 1] = frec[j + 3];
	}
/*  ----------- Find fields at the surface of the reflector */
	nfpatr_(&xfd[1], shadow_, xb, frec, efield, hfield);
	for (j = 1; j <= 3; ++j) {
/*  ----------- 2*(Surface Normal)*(Patch Area) */
/* L2: */
	    i__2 = j - 1;
	    r__1 = frec[j + 3] * (float)2. * frec[3];
	    unit[i__2].r = r__1, unit[i__2].i = (float)0.;
	}
	ccross_(unit, hfield, efield);
	for (j = 1; j <= 3; ++j) {
	    i__2 = j - 1;
	    curm[i__2].r = (float)0., curm[i__2].i = (float)0.;
	    if (*iadd != 1) {
		i__2 = j - 1;
		i__3 = j - 1;
		curj[i__2].r = efield[i__3].r, curj[i__2].i = efield[i__3].i;
	    }
	    if (*iadd == 1) {
		i__2 = j - 1;
		i__3 = j - 1;
		i__4 = j - 1;
		q__1.r = curj[i__3].r + efield[i__4].r, q__1.i = curj[i__3].i 
			+ efield[i__4].i;
		curj[i__2].r = q__1.r, curj[i__2].i = q__1.i;
	    }
/* L3: */
	}
/* L4: */
	io___16.ciunit = *lunit;
	io___16.cirec = i__ + 1;
	s_wdue(&io___16);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rfscur_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


