/* SPCCUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real bne, bnh;
    integer nappr;
    real pol;
} patr_;

#define patr_1 patr_

/* Table of constant values */

static integer c__1 = 1;
static real c_b9 = (float)90.;

/* Subroutine */ int spccur_(pkc, lunit)
real *pkc;
integer *lunit;
{
    /* Initialized data */

    static real tr = (float).01745329;
    static real zz = (float)376.73;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();
    double sqrt(), cos(), sin(), acos(), atan2(), r_sign();

    /* Local variables */
#define frec ((real *)equiv_2)
    static complex ephi;
#define ibuf ((integer *)equiv_0)
    static real phas;
    static complex ephs;
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static complex unit[3];
    static integer i__, j, l;
    static real theta;
    static complex efield[3], hfield[3];
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int ffdirc_();
    static real vp[3], vr[3];
    static complex etheta;
    static real vt[3], radius;
    extern /* Subroutine */ int cospat_(), ccross_();
    static real phi;
    extern doublereal dot_();

    /* Fortran I/O blocks */
    static cilist io___8 = { 0, 0, 0, 0, 1 };
    static cilist io___10 = { 0, 0, 0, 0, 1 };
    static cilist io___12 = { 0, 0, 0, 0, 0 };
    static cilist io___28 = { 0, 0, 0, 0, 0 };



/*  Adds Currents on Sphere using SPHGEO geometry file */

/*  PKC     Propagation constant */
/*  LUNIT   Logical unit of random access file for currents */

    io___8.ciunit = *lunit;
    s_rdue(&io___8);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    *pk = *pkc;
    ibuf[1] = 0;
    io___10.ciunit = *lunit;
    s_wdue(&io___10);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    i__1 = ibuf[0];
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___12.ciunit = *lunit;
	io___12.cirec = i__ + 1;
	s_rdue(&io___12);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
/* ------------- Convert position to spherical coordinates */
	radius = sqrt(dot_(frec, frec));
	phas = radius * *pk;
	r__1 = cos(phas);
	r__2 = -sin(phas);
	q__2.r = r__1, q__2.i = r__2;
	q__1.r = q__2.r / radius, q__1.i = q__2.i / radius;
	ephs.r = q__1.r, ephs.i = q__1.i;
	theta = acos(frec[2] / radius);
	if (dabs(frec[0]) > (float)1e-5) {
	    phi = atan2(frec[1], frec[0]);
	} else {
	    phi = r_sign(&c_b9, &frec[1]) * tr;
	}
	ffdirc_(&theta, &phi, vr, vt, vp);
	cospat_(&patr_1.nappr, &theta, &phi, &patr_1.bne, &patr_1.bnh, &
		patr_1.pol, &etheta, &ephi);
	for (l = 1; l <= 3; ++l) {
/* L3: */
	    i__2 = l - 1;
	    i__3 = l - 1;
	    unit[i__2].r = vr[i__3], unit[i__2].i = (float)0.;
	}
	for (l = 1; l <= 3; ++l) {
/* L4: */
	    i__2 = l - 1;
	    i__3 = l - 1;
	    q__3.r = vt[i__3] * etheta.r, q__3.i = vt[i__3] * etheta.i;
	    i__4 = l - 1;
	    q__4.r = vp[i__4] * ephi.r, q__4.i = vp[i__4] * ephi.i;
	    q__2.r = q__3.r + q__4.r, q__2.i = q__3.i + q__4.i;
	    q__1.r = q__2.r * ephs.r - q__2.i * ephs.i, q__1.i = q__2.r * 
		    ephs.i + q__2.i * ephs.r;
	    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
	}
	ccross_(efield, unit, hfield);
	for (j = 1; j <= 3; ++j) {
	    i__2 = j - 1;
	    i__3 = j - 1;
	    q__1.r = hfield[i__3].r / zz, q__1.i = hfield[i__3].i / zz;
	    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
/* L1: */
	    i__2 = j - 1;
	    r__1 = frec[j + 3] * frec[3];
	    unit[i__2].r = r__1, unit[i__2].i = (float)0.;
	}
	ccross_(unit, hfield, curj);
	ccross_(efield, unit, curm);
/* L2: */
	io___28.ciunit = *lunit;
	io___28.cirec = i__ + 1;
	s_wdue(&io___28);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* spccur_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


