/* SPHCUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int sphcur_(pkc, block, xb, lunit)
real *pkc;
/* Subroutine */ int (*block) ();
real *xb;
integer *lunit;
{
    /* Initialized data */

    static real xc[3] = { (float)0.,(float)0.,(float)0. };

    /* System generated locals */
    integer i__1, i__2;
    real r__1;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static complex unit[3];
    static integer i__, j;
    static complex efield[3], hfield[3];
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int nfpatr_(), ccross_();

    /* Fortran I/O blocks */
    static cilist io___7 = { 0, 0, 0, 0, 1 };
    static cilist io___9 = { 0, 0, 0, 0, 1 };
    static cilist io___11 = { 0, 0, 0, 0, 0 };
    static cilist io___16 = { 0, 0, 0, 0, 0 };



/*  Adds Currents on Sphere using SPHGEO geometry file */

/*  PKC     Propagation constant */
/*  LUNIT   Logical unit of random access file for currents */

    /* Parameter adjustments */
    --xb;

    /* Function Body */
    io___7.ciunit = *lunit;
    s_rdue(&io___7);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    *pk = *pkc;
    ibuf[1] = 0;
    io___9.ciunit = *lunit;
    s_wdue(&io___9);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    i__1 = ibuf[0];
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___11.ciunit = *lunit;
	io___11.cirec = i__ + 1;
	s_rdue(&io___11);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	nfpatr_(xc, block, &xb[1], frec, efield, hfield);
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    i__2 = j - 1;
	    r__1 = frec[j + 3] * frec[3];
	    unit[i__2].r = r__1, unit[i__2].i = (float)0.;
	}
	ccross_(unit, hfield, curj);
	ccross_(efield, unit, curm);
/* L2: */
	io___16.ciunit = *lunit;
	io___16.cirec = i__ + 1;
	s_wdue(&io___16);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* sphcur_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


