/* vdicmg.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int vdicmg_(freq, fd, al, polr, uu, ul, npts, curr, image, 
	lunit, zin)
real *freq, *fd, *al, *polr, *uu, *ul;
integer *npts;
real *curr;
integer *image, *lunit;
complex *zin;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.14159265;

    /* System generated locals */
    complex q__1;

    /* Builtin functions */
    double sqrt(), sin();

    /* Local variables */
    static integer i__, imagg;
    static complex z12;
    extern /* Subroutine */ int vdimuc_(), curcom_(), vdicur_();
    static real alc, fdi[3], uli[3], uui[3];


/*  Current multiplier for Vee dipole and Input Impedance */

/*  FREQ    Frequency (GHz) */
/*  FD(3)   Feed point (m) (height = FD(3)) */
/*  AL      Length of dipole (sum of both arms) (m) */
/*  POLR    Radius of rod of dipole */
/*  UU(3)   Direction of unit vector of upper arm */
/*  UL(3)   Direction of unit vector of lower arm */
/*  NPTS    Number of points along each arm */
/*  CURR    Multiplier on current magnitude (for mutual = 1) */
/*  IMAGE   0 - dipole alone, 1 - dipole over ground plane */
/*  LUNIT   Logical unit of file for currents */

    /* Parameter adjustments */
    --ul;
    --uu;
    --fd;

    /* Function Body */
/* ------------- Find currents on single dipole */
    imagg = 0;
    *curr = (float)1.;
    vdicur_(freq, &fd[1], al, &uu[1], &ul[1], npts, curr, &imagg, lunit);
/* ------------- Load into currents common */
    curcom_(lunit);
    fdi[0] = fd[1];
    fdi[1] = fd[2] + *polr;
    fdi[2] = fd[3];
/* ------------- Find self impedance */
    vdimuc_(fdi, al, &alc, &uu[1], &ul[1], npts, zin);
    if (*image == 1) {
	for (i__ = 1; i__ <= 2; ++i__) {
	    fdi[i__ - 1] = fd[i__];
	    uui[i__ - 1] = uu[i__];
/* L1: */
	    uli[i__ - 1] = ul[i__];
	}
	fdi[2] = -fd[3];
	uui[2] = -uu[3];
	uli[2] = -ul[3];
/* -------------  Find mutual impedance with image */
	vdimuc_(fdi, al, &alc, uui, uli, npts, &z12);
	q__1.r = zin->r - z12.r, q__1.i = zin->i - z12.i;
	zin->r = q__1.r, zin->i = q__1.i;
    }
    *curr = (float)1. / (sqrt(zin->r) * sin(pi * *al * *freq / cc));
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;

/*  Note fewer currents are needed for pattern calculations than for the 
*/
/*  self impedance.  The currents file can be reinitialized VDICUR with */
/*  fewer points but with CURR from this routine to normalize power to */
/*  1 watt. */

} /* vdicmg_ */

