      FUNCTION ALINP(X,XA,YA,NP,NI)
C 
C  INTERPOLATION ON TABLE 
C 
C  XA,YA  ARRAYS WITH NP POINTS, MONOTONIC X
C  NI  NUMBER OF POINTS IN INTERPOLATION (LAGRANGE) 
C 
      DIMENSION XA(1),YA(1),XI(5),YI(5) 
      NO=NI 
      IF(NO.GT.5)NO=5 
      NH=NO/2 
      OF=1. 
      IF(XA(NP).LT.XA(1))OF=-1. 
      NS=0
      IF((X-XA(NH))*OF.LT.0.)GOTO2
      NS=NP-NI
      NE=NP-NH
      IF((X-XA(NE))*OF.GT.0.)GOTO2
      NM=NH+1 
      DO1I=NM,NE
      NS=I-NM 
      IF((X-XA(I))*OF.LT.0.)GOTO2 
    1 CONTINUE
    2 DO3I=1,NI 
      J=NS+I
      XI(I)=XA(J) 
    3 YI(I)=YA(J) 
C 
C  INTERPOLATION
C 
      ALINP=0.
      DO4I=1,NI 
      YL=1. 
      DO5J=1,NI 
      IF(I.EQ.J)GOTO5 
      YL=YL*(X-XI(J))/(XI(I)-XI(J)) 
    5 CONTINUE
    4 ALINP=ALINP+YL*YI(I)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END 
