      SUBROUTINE CMTMUL(AM,X,Y)
C
C  Matrix multiplication between Complex Matrix and Complex Vector
C
C  AM(3,3)   Complex matrix
C  X(3)      Complex vector
C  Y(3)      Resulting vector
C
      COMPLEX AM(3,3),X(3),Y(3)
      DO2I=1,3
      Y(I)=0.
      DO1J=1,3
    1 Y(I)=Y(I)+AM(I,J)*X(J)
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
