      FUNCTION POLBKF(XB,XS,VR)
C
C  Polygon disk blockage function for far field
C
C  XB         Blockage function vector
C      1      Number of vertices
C      2 - 4  Unit normal
C      5 -    Vertices
C
C  XS(3)      Source point
C  VR(3)      Radial unit vector
C
      DIMENSION XB(1),XS(1),VR(1),PT(3)
      POLBKF=0.
      NV=XB(1)
      CALL PINTS(XS,VR,XB(5),XB(2),T,PT,NIS)
      IF(NIS.EQ.-1.OR.T.LT.0.)RETURN
      IF(POLYIN(PT,XB(5),NV,XB(2)).EQ.-1.)RETURN
      POLBKF=1.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
