      FUNCTION POLBKN(XB,XS,XF)
C
C  Polygon disk blockage function for near field
C
C  XB         Blockage function vector
C      1      Number of vertices
C      2 - 4  Unit normal
C      5 -    Vertices
C
C  XS(3)      Source point
C  VR(3)      Radial unit vector
C
      DIMENSION XB(1),XS(1),XF(1),PT(3),FS(3)
      CALL VLINC(-1.,XS,1.,XF,FS)
      FSL=SQRT(DOT(FS,FS))
      DO 1 I=1,3
    1 FS(I)=FS(I)/FSL
      POLBKN=0.
      NV=XB(1)
      CALL PINTS(XS,FS,XB(5),XB(2),T,PT,NIS)
      IF(NIS.EQ.-1.OR.T.LT.0.)RETURN
      TEST=POLYIN(PT,XB(5),NV,XB(2))
      IF(TEST.EQ.-1.)RETURN
      IF(T.GT.FSL)RETURN
      POLBKN=1.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
