      SUBROUTINE POLYNM(VT,AN)
C
C  Unit normal to planar polygon
C
C  VT(3,NT)   Vertices of polygon
C  AN(3)      Returned unit normal
C
C  It is assumed that the vertices are ordered CCW around the normal
C
      DIMENSION VT(1),AN(1),V1(3),V2(3)
      DO 1 I=1,3
      V1(I)=VT(I+6)-VT(I+3)
    1 V2(I)=VT(I)-VT(I+3)
      CALL CROSS(V1,V2,AN)
      AL=SQRT(DOT(AN,AN))
      DO 2 I=1,3
    2 AN(I)=AN(I)/AL
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
