      PROGRAM SPCATR
C
C  Green's function analysis of square patch pattern
C
C  WRITTEN   11 Jul 94
C  LAST EDIT 07 May 95
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION THT(361),AEI(361),VR(3),VT(3),VP(3),XF(3),XC(3)
     1,UF(2),XB(3)
      COMPLEX EITH(361),EIPH(361),EII,EFIELD(3),HFIELD(3),CURJA,CURMA
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      CHARACTER UN(2)*4
      EXTERNAL BLOCKN
      DATA TR/.01745329/,IC/0/,GCONS/.182637/,XC/0.,0.,0./
     1,UF/.0254,.01/,UN/' in.',' cm.'/
      LU=66
      WRITE(6,1)
    1 FORMAT(' Green s function calculation of Square Patch Pattern',
     3/,' Line Printer Output? ',$)
      LPR=NYES(K)
      WRITE(6,40)
   40 FORMAT(' Enter units: 1 in., 2 cm ',$)
      READ(5,*)IUN
      IF(LPR.EQ.1)OPEN(66,FILE='spcatr.out')
      OPEN(19,FILE='spcatr.dat',ACCESS='DIRECT',RECL=76)
      WRITE(6,2)
    2 FORMAT(' Enter effective width of Patch ',$)
      READ(5,*)WID
      WIDTH=WID*UF(IUN)
    3 WRITE(6,4)
    4 FORMAT(' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      IF(LPR.EQ.1)WRITE(LU,5)WID,UN(IUN),FREQ
    5 FORMAT(' Effective width:      ',F8.3,A4,/,
     1       ' Frequency (GHz):      ',F8.3)
      WRITE(6,32)
   32 FORMAT(' Enter polarization: 0 linear, -1 RHC, +1 LHC ',$)
      READ(5,*)POL
      WRITE(6,33)
   33 FORMAT(' Enter points on edge of patch for integral ',$)
      READ(5,*)NPTS
      CALL SPACUR(WIDTH,FREQ,POL,NPTS,19)
      CALL CURCOM(19)
    6 WRITE(6,7)
    7 FORMAT(' Enter: 1 Conic Cut, 2 Great Circle (Azimuth) ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.2)THEN
      WRITE(6,8)
    8 FORMAT(' Enter Theta Start,Stop,Step ',$)
      ELSE
      WRITE(6,9)
    9 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ENDIF
      READ(5,*)T1,T2,TS
      NT=(T2-T1)/TS+1.4
      IF(NT.GT.361)STOP
      IF(IPAT.EQ.2)THEN
      WRITE(6,10)
   10 FORMAT(' Enter Constant Phi Angle ',$)
      ELSE
      WRITE(6,11)
   11 FORMAT(' Enter Constant Theta Angle ',$)
      ENDIF
      READ(5,*)AN
      WRITE(6,34)
   34 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,35)
   35 FORMAT(' Enter radius ',$)
      READ(5,*)DIST
      WRITE(66,36)DIST
   36 FORMAT(' Near field pattern at Radius = ',F8.2)
      DIST=DIST*UF(IUN)
      ENDIF
      IF(IPAT.EQ.1)THETA=AN*TR
      IF(IPAT.EQ.2)PHI=AN*TR
      IF(IPAT.EQ.2.AND.LPR.EQ.1)WRITE(LU,12)AN
   12 FORMAT(/,' Constant Phi Angle: ',F7.2)
      IF(IPAT.EQ.1.AND.LPR.EQ.1)WRITE(LU,13)AN
   13 FORMAT(/,' Constant Theta Angle: ',F7.2)
C
C  CALCULATE PATTERN
C
      DO14I=1,NT
      THT(I)=T1+FLOAT(I-1)*TS
      IF(IPAT.EQ.2)THETA=THT(I)*TR
      IF(IPAT.EQ.1)PHI=THT(I)*TR
      IF(NEAR.EQ.1)THEN
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      DO37J=1,3
   37 XF(J)=VR(J)*DIST
      CALL NRPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      EITH(I)=0.
      EIPH(I)=0.
      DO38J=1,3
      EITH(I)=DIST*EFIELD(J)*VT(J)*GCONS+EITH(I)
   38 EIPH(I)=DIST*EFIELD(J)*VP(J)*GCONS+EIPH(I)
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,EITH(I),EIPH(I))
      EITH(I)=EITH(I)*GCONS
      EIPH(I)=EIPH(I)*GCONS
      ENDIF
   14 CONTINUE
      KPM=-1
   15 IF(IC.EQ.0)GOTO17
      WRITE(6,16)
   16 FORMAT(/,' Normalize to Last Plot Maximum? ',$)
      KPM=NYES(K)
   17 WRITE(6,18)
   18 FORMAT(' Enter Output Code:',/,4X,' 1 E Theta, 2 E Phi'
     1,' 3 RHC, 4 LHC, 5 Max. Lin., 6 Min. Lin.,'
     2/,' 7 +45 Comp., 8 -45 Comp., 9 Power ',$)
      READ(5,*)IOUT
      AEX=-120.
      DO19I=1,NT
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEI(I),PHS)
      IF(AEI(I).GT.AEX)THEN
      AEX=AEI(I)
      THX=THT(I)
      ELSE
      ENDIF
   19 CONTINUE
   20 IF(IC.EQ.0)EMAX=AEX
      IF(KPM.EQ.-1)EMAX=AEX
      IC=IC+1
      WRITE(6,21)
   21 FORMAT(' Plot? ',$)
      IF(NYES(K).NE.1)GOTO22
      CALL PPATP(T1,T2,TS,AEI,EMAX,IP)
   22 WRITE(6,23)
   23 FORMAT(' List? ',$)
      IF(NYES(K).EQ.1)THEN
      IF(IPAT.EQ.2.AND.LPR.EQ.1)WRITE(LU,27)
      IF(IPAT.EQ.1.AND.LPR.EQ.1)WRITE(LU,28)
      IF(IPAT.EQ.2)WRITE(6,27)
      IF(IPAT.EQ.1)WRITE(6,28)
      DO24I=1,NT
      THETA=T1+FLOAT(I-1)*TS
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEX,PHS)
      WRITE(6,25)THETA,AEX,PHS
   24 IF(LPR.EQ.1)WRITE(LU,25)THETA,AEX,PHS
   25 FORMAT(F6.1,4X,F7.2,2X,F7.2)
   27 FORMAT(/,' Theta',2X,' Ampl(dB)',3X,' Phase',/)
   28 FORMAT(/,'  Phi ',2X,' Ampl(dB)',3X,' Phase',/)
      ELSE
      END IF
      WRITE(6,29)
   29 FORMAT(' Another Polarization? ',$)
      IF(NYES(K).EQ.1)GOTO15
      WRITE(6,30)
   30 FORMAT(' New Pattern Cut? ',$)
      IF(NYES(K).EQ.1)GOTO6
      WRITE(6,31)
   31 FORMAT(' New Frequency? ',$)
      IF(NYES(K).EQ.1)GOTO3
      END
      SUBROUTINE PMAGC(E,AMP,PHASE)
      COMPLEX E
      IF(CABS(E).GT.1.E-12)THEN
      AMP=20.*ALOG10(CABS(E))
      PHASE=ATAN2(AIMAG(E),REAL(E))/.01745329
      ELSE
      AMP=-240.
      PHASE=0
      ENDIF
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA & PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA & PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
