      SUBROUTINE SPCCUR(PKC,LUNIT)
C
C  Adds Currents on Sphere using SPHGEO geometry file
C
C  PKC     Propagation constant
C  LUNIT   Logical unit of random access file for currents
C
      COMPLEX CURJ(3),CURM(3),EFIELD(3),HFIELD(3),UNIT(3),ETHETA,
     1 EPHI,EPHS
      DIMENSION FREC(19),VR(3),VT(3),VP(3)
      INTEGER*4 IBUF(19)
      COMMON /PATR/BNE,BNH,NAPPR,POL
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      DATA TR/.01745329/,ZZ/376.73/
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=0
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 2 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------------- Convert position to spherical coordinates
      RADIUS=SQRT(DOT(FREC,FREC))
      PHAS=RADIUS*PK
      EPHS=CMPLX(COS(PHAS),-SIN(PHAS))/RADIUS
      THETA=ACOS(FREC(3)/RADIUS)
      IF(ABS(FREC(1)).GT.1.E-5)THEN
      PHI=ATAN2(FREC(2),FREC(1))
      ELSE
      PHI=SIGN(90.,FREC(2))*TR
      ENDIF
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      CALL COSPAT(NAPPR,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
      DO 3 L=1,3
    3 UNIT(L)=VR(L)
      DO 4 L=1,3
    4 EFIELD(L)=(ETHETA*VT(L)+EPHI*VP(L))*EPHS
      CALL CCROSS(EFIELD,UNIT,HFIELD)
      DO 1 J=1,3
      HFIELD(J)=HFIELD(J)/ZZ
    1 UNIT(J)=FREC(J+4)*FREC(4)
      CALL CCROSS(UNIT,HFIELD,CURJ)
      CALL CCROSS(EFIELD,UNIT,CURM)
    2 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
