% MATLAB script file for calculating far-field 
% spillover patterns of reflector
% 
% PART b: feed currents and patterns
%

po09b	% feed aperture surface definition
po09c	% feed aperture currents
po09d	% feed radiation patterns

EthF=EM(:,1)+HJ(:,2)*Z0;	% theta pol E field
EphF=EM(:,2)-HJ(:,1)*Z0; 	% phi pol E field
ErF=sqrt(.5)*(EthF+i*EphF);	% RHCP E field
ElF=sqrt(.5)*(EthF-i*EphF);	% LHCP E field

PthFdB=PthdB;
PphFdB=PphdB;
PrFdB=PrdB;
PlFdB=PldB;

%